
-- # import id
-- # import prop

infixr 1 $

(∘) (A, B, C : Set) : (B -> C) -> (A -> B) -> A -> C
f ∘ g = \x -> f (g x)

($) (A, B : Set) : (A -> B) -> A -> B
f $ x = f x

data Bool : Set where
  false : Bool
  true  : Bool

data T : Bool -> Set where
  tTrue : T true

tFalse (C:Set) : T false -> C

data (×) (A,B:Set) : Set where
  pair : A -> B -> A × B

fst (A, B : Set) : A × B -> A
fst (pair x _) = x

snd (A, B : Set) : A × B -> B
snd (pair _ y) = y

swap (A, B : Set) : A × B -> B × A
swap p = pair (snd p) (fst p)

uncurry (A, B, C : Set) : (A -> B -> C) -> (A × B -> C)
uncurry f (pair x y) = f x y

curry (A, B, C : Set) : (A × B -> C) -> (A -> B -> C)
curry f x y = f (pair x y)

id (A:Set) : A -> A
id x = x

flip (A, B, C : Set) : (A -> B -> C) -> B -> A -> C
flip f x y = f y x

const (A, B : Set) : A -> B -> A
const x y = x

-- Properties

injPair (A,B:Set)(x1,x2:A)(y1,y2:B) : pair x1 y1 == pair x2 y2 -> x1 == x2 /\ y1 == y2
injPair refl = andI refl refl

