{-
    Commutativity of addition.
    (The Logical Framework approach)
-}

-- # import Property

-- Natural numbers

Nat   : Set
zero  : Nat
succ  : Nat -> Nat

-- Equality

infix 8 ==
(==) = Eq Nat

-- Induction

ind : (P : Nat -> Prop) ->
       P 0 ->
       ((n : Nat) -> P n -> P (succ n)) ->
       (n : Nat) -> P n

-- Addition

infixl 10 +
(+)  : Nat -> Nat -> Nat
plus : (n, m : Nat) -> n + 0      == n  /\
			 n + succ m == succ (n + m)

-- Properties

PlusZero : Nat -> Prop
PlusZero n = 0 + n == n

plusZero : (n : Nat) -> PlusZero n
plusZero = ind PlusZero base step
  where
    base : PlusZero 0
    base = fol-plugin(plus)

    step : (m : Nat) ->        PlusZero m
			  ==> -----------------
			      PlusZero (succ m)

    step = fol-plugin(plus)

PlusSucc : Nat -> Nat -> Prop
PlusSucc n m = succ n + m == succ (n + m)

plusSucc : (n, m : Nat) -> PlusSucc n m
plusSucc n = ind (PlusSucc n) fol-plugin(plus) fol-plugin(plus)

PlusCommute : Nat -> Nat -> Prop
PlusCommute n m = n + m == m + n

plusCommute : (n, m : Nat) -> PlusCommute n m
plusCommute n = ind (PlusCommute n)
		    fol-plugin(plus, plusZero)
		    fol-plugin(plus, plusSucc)

