-- a little theory of Dijkstra

D : Set
(*) : D -> D -> D

infix 10 *
infix 8 <=
infix 7 ==

(==) : D -> D -> Prop
(==) = Eq D

(<=) : D -> D -> Prop
(<=) x y = (x * y) == y

idem : (X:Set) -> (X->X->X) -> Prop
idem X g = (x:X) -> Eq X (g x x) x

assoc : (X:Set) -> (X->X->X) -> Prop
assoc X g = (x:X) -> (y:X) -> (z:X) -> Eq X (g x (g y z)) (g (g x y) z)

com : (X:Set) ->  (X->X->X) -> Prop
com X g = (x:X) -> (y:X) -> (z:X) -> Eq X (g x y) (g y x)

lem1 : (idem D (*)) -> (x:D) -> x <= x
lem1 h x = fol-plugin(h)

lem2 : ((x:D) -> x <= x) -> (x:D) -> x * x == x
lem2 h x = fol-plugin(h)

lem3 : (assoc D (*)) ->
        (x:D) -> (y:D) -> (z:D) -> x <= y /\ y <= z ==> x <= z
lem3 h x y z h1 = fol-plugin(h,h1)

lem4 : (com D (*)) ->
        (x:D) -> (y:D) -> x <= y /\ y <= x ==> x == y
lem4 h x y h1 = fol-plugin(h,h1)

lem5 : (f:D->D) ->
        ((x:D) -> (y:D) -> f (x*y) == f x * f y) ->
        (x:D) -> (y:D) -> x <= y ==> f x <= f y 
lem5 f h x y h1 = fol-plugin(h,h1)

lem6 : (idem D (*) /\ assoc D (*) /\ com D (*)) ->
        (x:D) -> (y:D) -> (z:D) -> y <= z ==> x * y <= x * z
lem6 h x =
 let
  f : D -> D
  f = (*) x 
  rem : (y:D) -> (z:D) -> f (y*z) == f y * f z
  rem = \ y -> \ z -> fol-plugin(h)
 in
  lem5 ((*) x) rem
