-- # import Property

-- some logical axioms

Obj : Set

Hom : Obj -> Obj -> Set

id : (A:Obj) -> Hom A A

comp : (A:Obj) -> (B:Obj) -> (C:Obj) -> Hom A B -> Hom B C -> Hom A C

axId1 : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> Eq (Hom A B) f (comp A A B (id A) f)

axId2 : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> Eq (Hom A B) f (comp A B B f (id B))

assoc : (A:Obj) -> (B:Obj) -> (C:Obj) -> (D:Obj) -> 
         (f:Hom A B) -> (g:Hom B C) -> (h:Hom C D) ->
         Eq (Hom A D) (comp A C D (comp A B C f g) h) (comp A B D f (comp B C D g h))

isMono : (A:Obj) -> (B:Obj) -> Hom A B -> Prop

defMono : (A:Obj) -> (B:Obj) -> (f:Hom A B) -> 
            isMono A B f <=> ((C:Obj) -> (g:Hom C A) -> (h:Hom C A) -> 
            Eq (Hom C B) (comp C A B g f) (comp C A B h f) -> Eq (Hom C A) g h)

T : Obj

one : (A:Obj) -> Hom A T

eqOne : (A:Obj) -> (f:Hom A T) -> Eq (Hom A T) f (one A)

prop : (A:Obj) -> (f:Hom T A) -> isMono T A f
prop A f = fol-plugin(eqOne,defMono,assoc)


prod : Obj -> Obj -> Obj

p1 : (A:Obj) -> (B:Obj) -> Hom (prod A B) A
p2 : (A:Obj) -> (B:Obj) -> Hom (prod A B) B

pair : (A:Obj) -> (B:Obj) -> (C:Obj) -> Hom C A -> Hom C B -> Hom C (prod A B)

axP1 : (A:Obj) -> (B:Obj) -> (C:Obj) -> (a:Hom C A) -> (b:Hom C B) -> 
        Eq (Hom C A) a (comp C (prod A B) A (pair A B C a b) (p1 A B))
axP2 : (A:Obj) -> (B:Obj) -> (C:Obj) -> (a:Hom C A) -> (b:Hom C B) -> 
        Eq (Hom C B) b (comp C (prod A B) B (pair A B C a b) (p2 A B))

prop1 : (A:Obj) -> Eq (Hom A A) (id A) (comp A (prod T A) A (pair T A A (one A) (id A)) (p2 T A))
prop1 A = fol-plugin(axP1,axP2,eqOne,assoc,axId1,axId2)

prop2 : (A:Obj) -> 
         Eq (Hom (prod T A) (prod T A)) (id (prod T A)) (comp (prod T A) A (prod T A) (p2 T A) (pair T A A (one A) (id A)) )
prop2 A = fol-plugin(axP1,axP2,eqOne,assoc,axId1,axId2)

unProd : (A:Obj) -> (B:Obj) -> (C:Obj) -> (f:Hom C (prod A B)) ->
          Eq (Hom C (prod A B)) f (pair A B C (comp C (prod A B) A f (p1 A B)) (comp C (prod A B) B f (p2 A B)))

prop4 : (A:Obj) -> (B:Obj) -> (C:Obj) -> (a:Hom C A) -> (b:Hom C B) -> (f:Hom C (prod A B)) ->
          Eq (Hom C A) (comp C (prod A B) A f (p1 A B)) a ->
          Eq (Hom C B) (comp C (prod A B) B f (p2 A B)) b ->
          Eq (Hom C (prod A B)) f (pair A B C a b)
prop4 A B C a b f h1 h2 = fol-plugin(axP1,axP2,assoc,axId1,axId2,unProd,h1,h2)


